/*
**
**                           Main.c
**
**
**********************************************************************/
/*
   Last committed:     $Revision: 00 $
   Last changed by:    $Author: $
   Last changed date:  $Date:  $
   ID:                 $Id:  $

**********************************************************************/
#include "stm32f10x_conf.h"
#include "SysTimer.h"

extern uint32_t SystemCoreClock;

void NMI_Handler(void)
{
    if (RCC_GetITStatus(RCC_IT_CSS)) //   Clock Security System.
    {
        RCC_ClearITPendingBit(RCC_IT_CSS);
        RCC_ClockSecuritySystemCmd(DISABLE);      // Clock Security System.

        //    HSI (RC  8 ).
        RCC_PLLCmd(DISABLE); //   .
        RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_CFGR_PLLMULL16); //      (8/2*16=64).
        RCC_PLLCmd(ENABLE); //   .
        while ((RCC->CR & RCC_CR_PLLRDY) == 0);     //    .
        RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK); //     .

        SystemCoreClockUpdate(); //    .
        SysTim_Init(100);
    }
}


int main(void)
{
    SystemCoreClockUpdate();
    SysTim_Init(100);

    if (RCC->CR & RCC_CR_HSERDY) //   HSE ( ).
    {
        RCC_HSICmd(ENABLE); //  RC  8 .
        RCC_ClockSecuritySystemCmd(ENABLE); //  Clock Security System.
    }


    GPIO_InitTypeDef Gpio;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE); //    GPIOC

    Gpio.GPIO_Pin = GPIO_Pin_13;
    Gpio.GPIO_Mode = GPIO_Mode_Out_PP;
    Gpio.GPIO_Speed = GPIO_Speed_50MHz;

    GPIO_Init(GPIOC, &Gpio); //  GPIOC.

    while(1)
    {
        if (RCC->CR & RCC_CR_HSERDY) //   HSE ( ).
        {
            GPIO_SetBits(GPIOC, GPIO_Pin_13); //  .
            SysTim_DelayMS(500);
            GPIO_ResetBits(GPIOC, GPIO_Pin_13);
            SysTim_DelayMS(500);
        }
        else //   HSI (RC ).
        {
            GPIO_SetBits(GPIOC, GPIO_Pin_13); //  .
            SysTim_DelayMS(900);
            GPIO_ResetBits(GPIOC, GPIO_Pin_13);
            SysTim_DelayMS(100);
        }

    }
}
